/***
*** Interface: pspice 16.6
 *** created by: admsXml-2.3.0 - Mon, 25 Jul 2016 14:37:00 ***/
#include "StdAfx.h"
#include "pspEngFunc.h"
#include "capdefs.h"
int capmodel::ModChk ()
     /* load the cap device structure with those pointers needed later 
      * for fast matrix loading 
      */

{if(c1_Given == FALSE) c1=0;
if(c2_Given == FALSE) c2=0;

init();

return(OK);
}
void capinstance::setNodeName(int i, const char* lName) {
	int nodeIndex=0;
	while(1) {
		if(i == nodeIndex) {
			strcpy(pNodeStr, lName);
			break;
		}
		nodeIndex++;
		if(i == nodeIndex) {
			strcpy(nNodeStr, lName);
			break;
		}
		nodeIndex++;
		// Should never reach here
		printf("\n ERROR Can not set Node Name");
		break;
	}
}
int capinstance::AddInternalNodes(PSpiceDeviceMiscInfo* pMiscInfo) {
      init();

      int i=0;
        pNode = i;
        i++;
        nNode = i;
        i++;
  int mystatecount = 0;
  int *states = &mystatecount;
      /* set states */
      state_p_n = *states; *states += 2;
	  states0 = new double[*states];
	  memset(states0, 0, *states * sizeof(double));
	  states1 = new double[*states];
	  memset(states1, 0, *states * sizeof(double));
      /* set Sparse Matrix Pointers */
      PTR_J_p_p_required=1;
      PTR_J_p_n_required=1;
      PTR_J_n_p_required=1;
      PTR_J_n_n_required=1;
      guesstopology(pMiscInfo,capmodPtr);
      /* Internal Nodes */
      {
        int error=0;
        char* tmp = NULL; // memory allocated by pspice
        std::string lIntNodeNameBase = capname;
        std::string lIntNodeName;
        char i='0';
      }
    return OK;
}
void capinstance::AddIMatrix() {
	mResiduals.clear();
	int nodeIndex = -1;
	nodeIndex++;
	fp_getRHSPtr(&intNodes[nodeIndex], pNodeStr);
	mResiduals.insert(std::pair < int, double* > (pNode, intNodes[nodeIndex]));
	nodeIndex++;
	fp_getRHSPtr(&intNodes[nodeIndex], nNodeStr);
	mResiduals.insert(std::pair < int, double* > (nNode, intNodes[nodeIndex]));
/* for Internal nodes */
	std::string lIntNodeNameBase = capname;
	std::string lIntNodeName; 
	char j= '0';
}
void capinstance::createMatrixStencil () {
        if(PTR_J_p_p_required==1)
        {
           fp_getMatrixPtr(&PTR_J_p_p, pNodeStr,pNodeStr);
        }
        if(PTR_J_p_n_required==1)
        {
           fp_getMatrixPtr(&PTR_J_p_n, pNodeStr,nNodeStr);
        }
        if(PTR_J_n_p_required==1)
        {
           fp_getMatrixPtr(&PTR_J_n_p, nNodeStr,pNodeStr);
        }
        if(PTR_J_n_n_required==1)
        {
           fp_getMatrixPtr(&PTR_J_n_n, nNodeStr,nNodeStr);
        }
	AddIMatrix();
}
void capinstance::initMatrix() {
           fp_applyValueItem(PTR_J_p_p, 0);
           fp_applyValueItem(PTR_J_p_n, 0);
           fp_applyValueItem(PTR_J_n_p, 0);
           fp_applyValueItem(PTR_J_n_n, 0);
        std::map<int, double*>::iterator it;
	it = mResiduals.begin();
	while(it != mResiduals.end()) {
		fp_applyValueItem( it->second, 0);
		it++;
	}
}
void capmodel::setParamValue(const char* pName, double pValue) {
  if(mParamGivenInitialized == 0) {
  // INIT
       c1_Given = 0;
       c2_Given = 0;
 mParamGivenInitialized = 1;
}
    if(_stricmp(pName, "c1") == 0) {
       c1_Given = 1;
       c1 = pValue;
    }
    if(_stricmp(pName, "c2") == 0) {
       c2_Given = 1;
       c2 = pValue;
    }
}
